//Interface base class. To be overriden by the service that implements it.

#pragma once

class INetworkProvider
{
public:
	virtual auto Init() -> void = 0;
	virtual auto Send(const char* address, int port, void* dataLocation, int dataSize, bool connectionless) -> int = 0;
	virtual auto Receive(int port, void* bufferLocation, int bufferSize, bool connectionless) -> int = 0;
	virtual auto Shutdown() -> void = 0;
};