#include "Network_Core.h"
#include <cassert>
#include <iostream>

Network_Core::~Network_Core()
{
	Shutdown();
}

Network_Core* Network_Core::Instance()
{
	static Network_Core instance;
	return &instance;
}

void Network_Core::Init()
{
	//Initialize Winsock
	iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	assert(iResult == 0);		
}

void Network_Core::ShowLastError(std::string callingFunctionName)
{
	int error = WSAGetLastError();
	std::cout << "Winsock Error: " << error << " from " << callingFunctionName << std::endl;
}

void Network_Core::Shutdown()
{
	WSACleanup();
}