/*      Main Class for GSP-420 Network Core
		Team G: Alex Cary, Tylor Emmett, Javier Heard

		Changlog:
		1/17/15 - Tylor - Initial Version
		1/31/15 - Tylor - Added WSA Error Checking
		2/1/15 - Tylor - Added WSA Cleanup to destructor.



*/
#pragma once

#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <string>

#pragma comment (lib, "Ws2_32.lib")
#pragma comment (lib, "Mswsock.lib")
#pragma comment (lib, "AdvApi32.lib")

namespace NetworkCore
{
	enum Result{CONNECTED, CONNECTION_FAILED, PACKET_SENT, SEND_FAILED, PACKET_RECEIVED, RECEIVE_FAILED, DISCONNECTED, DISCONNECT_FAILED, BIND_FAILED, SOCKET_BOUND};
}

//Singleton class. Simply initializes Winsock
class Network_Core 
{
private:
	Network_Core(){}
	~Network_Core();
	Network_Core(Network_Core&){}
	void operator=(Network_Core&){}
		
	//Winsock Init Variables
	WSADATA  wsaData;
	int iResult;
	
public:
	//Public accessor
	static Network_Core* Instance();
	//Initalizes Winsock
	void Init();
	//Error reporting
	void ShowLastError(std::string callingFuncationName);
	void Shutdown();
};