/*		TCPListener Class for GSP-420 Network Core
		Team G: Alex Cary, Tylor Emmett, Javier Heard

		Changlog:
		1/17/15 - Tylor - Initial Version

		1/21/15 - Heard
		NOTES: Maybe we should have some type of way to check if a function fails;
		with that we would call WSACleanup() after a function fails, such as CreateSocket()
		if it creates an invalid socket. I came up with this idea of adding bSocketError to the
		core to check if a socket fails to create or not like this: bSocketError = CreateSocket().
		If there is no problem CreateSocket() returns false. Alternatively, it could be done with
		simple conditional statements like: if(!listeningSocket.CreateSocket()) { return an error }.

		For bool functions TRUE means it succeeded, FALSE means it failed.
		
		2/1/15 - Reformatted this as a child class of the TCP Socket, as it is essentially a specialized version.
*/

#pragma once

#include "Network_Core.h"
#include "TCPSocket.h"

class TCPListener : public TCPSocket
{

public:

	TCPListener(int port);
	bool Listen();
	
};