/*      TCP Socket Class for GSP-420 Network Core
		Team G: Alex Cary, Tylor Emmett, Javier Heard

		Changlog:
		1/17/15 - Tylor - Initial Version
		
		1/21/15 - Heard
		NOTES: Here are useful TCP references:	https://msdn.microsoft.com/en-us/library/aa454002.aspx
												https://msdn.microsoft.com/en-us/library/windows/desktop/ms738545%28v=vs.85%29.aspx

		Continue with notes...
*/
#pragma once

#include "Network_Core.h"
#include "Packet.h"

class TCPSocket
{
protected:

	SOCKET			gSocket;
	int				portNumber;
	int				WSALastError;

public:

	TCPSocket(int port);
	~TCPSocket();
	NetworkCore::Result		Connect(const char* target, int port);
	NetworkCore::Result		Send(Packet dataIn);
	NetworkCore::Result		BindSocket();
	NetworkCore::Result		Receive(Packet dataOut);
	NetworkCore::Result		Disconnect();

private:

	bool					CreateSocket();
};