/*      UDPSocket Class for GSP-420 Network Core
		Team G: Alex Cary, Tylor Emmett, Javier Heard

		Changlog:
		1/17/15 - Tylor - Initial Version
		1/31/15 - Tylor - Implemented the remaining UDP socket code. Added BindSocket for server applications.

*/
#pragma once

#include "Network_Core.h"
#include "Packet.h"

class UDPSocket
{

private:

	SOCKET			gSocket;
	int				portNumber;

protected:

	int				WSALastError;

public:

	UDPSocket(int port);
	~UDPSocket();
	NetworkCore::Result Send(const char* target, int port, Packet dataIn);
	NetworkCore::Result Receive(Packet dataOut, int sizeRecieved);
	NetworkCore::Result BindSocket();

private:
	bool CreateSocket();
	
};